#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fstream>
#include<iostream>
#define Pi 3,1415926535

//Questo script è stato realizzato per risolvere equazioni differenziali parziali praboliche. In particolare risolve l'equazione del calore numericamente

double **allocate2(double **w,int n,int m)
{
    int i;
    w=(double **)calloc(n+1,sizeof(double *));
    for(i=0;i<=n;i++)
    {
        w[i]=(double *)calloc(m+1,sizeof(double));
    }
    return w;
}


double f(double x)
{
    double g,y;
    y=x*Pi;
    g=sin(y);
    return g;
}

double g(double x)
{
    return 0;
}

void writeout2(char *filename,double *x,double *t,double **p,int N,int M)
{
    int i,j;
    FILE *fptr;
    fptr=fopen(filename,"w");
    for(j=0;j<=N;j++)
    {
        for(i=0;i<=M;i++)
            fprintf(fptr,"%lf \t %lf \t %lf \n",x[i],t[j],p[i][j]);
    }
    fclose(fptr);
}

using namespace std;
int main()
{
    remove("WaveData.dat");
    int m,i,j,N;
    double L=0,T=0,alpha=0,h,k,lam; /*N=maximum number of iterations*/
    double *t,*x,**w=NULL;
    char data[20]="WaveData.dat";
    
    while(L<=0 && T<=0)
    {
        cout << "Insert endpoint L, the maximum time T, the constant alpha:"<<endl;
        cout << "L=";
        cin >> L;
        cout << "T=";
        cin >> T;
        cout << "alpha=";
        cin >> alpha;
    }
    cout << "Insert the integer m for the division of the spatial intervall" << endl;
    cin >> m;
    cout << "Insert the integer N for the division of the time intervall" << endl;
    cin >> N;
    
    
    t=(double*)calloc(N+1,sizeof(double));
    x=(double*)calloc(m+1,sizeof(double));
    w=allocate2(w,m,N);
    
    h=L/m;
    k=T/N;
    lam=alpha*k/h;
    
    for(j=1;j<=N;j++)
    {
        w[0][j]=0;
        w[m][j]=0;
    }
    
    w[0][0]=f(0);
    w[m][0]=f(L);
    
    for(i=1;i<m;i++)
    {
        w[i][0]=f(i*h);
        w[i][1]=(1-pow(lam,2))*f(i*h)+pow(lam,2)/2*(f((i+1)*h)+f((i-1)*h))+k*g(i*h);
    }
    
    for(j=1;j<N;j++)
    {
        for(i=1;i<m;i++)
            w[i][j+1]=2*(1-pow(lam,2))*w[i][j]+pow(lam,2)*(w[i+1][j]+w[i-1][j])-w[i][j-1];
    }

    
    for(i=0;i<=m;i++)
        x[i]=i*h;
    for(j=0;j<=N;j++)
        t[j]=j*k;
    
    cout << "I risultati sono stati stampati nel file WaveData.dat" << endl;
    writeout2(data,x,t,w,N,m);
    
    /*system(" /Applications/Mathematica.app/Contents/MacOS/Mathematica /Users/Matteo/Desktop/Esame_Lab_Fis_Comp/Mathematica/Mathematica_Project.nb");*/
    
              return 0;
}

